# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from pprint import pformat
from six import iteritems


class BuildConfigurationSetRest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        BuildConfigurationSetRest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'int',
            'name': 'str',
            'product_version_id': 'int',
            'build_configuration_ids': 'list[int]'
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'product_version_id': 'productVersionId',
            'build_configuration_ids': 'buildConfigurationIds'
        }

        self._id = None
        self._name = None
        self._product_version_id = None
        self._build_configuration_ids = None

    @property
    def id(self):
        """
        Gets the id of this BuildConfigurationSetRest.


        :return: The id of this BuildConfigurationSetRest.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this BuildConfigurationSetRest.


        :param id: The id of this BuildConfigurationSetRest.
        :type: int
        """
        self._id = id

    @property
    def name(self):
        """
        Gets the name of this BuildConfigurationSetRest.


        :return: The name of this BuildConfigurationSetRest.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this BuildConfigurationSetRest.


        :param name: The name of this BuildConfigurationSetRest.
        :type: str
        """
        self._name = name

    @property
    def product_version_id(self):
        """
        Gets the product_version_id of this BuildConfigurationSetRest.


        :return: The product_version_id of this BuildConfigurationSetRest.
        :rtype: int
        """
        return self._product_version_id

    @product_version_id.setter
    def product_version_id(self, product_version_id):
        """
        Sets the product_version_id of this BuildConfigurationSetRest.


        :param product_version_id: The product_version_id of this BuildConfigurationSetRest.
        :type: int
        """
        self._product_version_id = product_version_id

    @property
    def build_configuration_ids(self):
        """
        Gets the build_configuration_ids of this BuildConfigurationSetRest.


        :return: The build_configuration_ids of this BuildConfigurationSetRest.
        :rtype: list[int]
        """
        return self._build_configuration_ids

    @build_configuration_ids.setter
    def build_configuration_ids(self, build_configuration_ids):
        """
        Sets the build_configuration_ids of this BuildConfigurationSetRest.


        :param build_configuration_ids: The build_configuration_ids of this BuildConfigurationSetRest.
        :type: list[int]
        """
        self._build_configuration_ids = build_configuration_ids

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
	    elif isinstance(value, datetime):
		result[attr] = str(value.date())
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()
